## mwarning-KadNode.zip

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.23)
project(KadNode C)

#NOTE: The file is not used by build but useful for IDE

OPTION(DNS "DNS Proxy" ON)
OPTION(TLS "TLS Authentication" ON)
OPTION(BOB "BOB Authentication" ON)
OPTION(LPD "Local Peer Discovery (LPD) Support" ON)
OPTION(CMD "kadnode-ctl KadNode Control Program" ON)
OPTION(NATPMP "Port Forwarding NAT-PMP/PCP" OFF)
OPTION(UPNP "Port Forwarding UPnP" OFF)

SET(CMAKE_C_STANDARD 11)
ADD_DEFINITIONS(-Os -Wall -Wwrite-strings -pedantic)

SET(SOURCES src/announces.c
        src/conf.c
        src/kad.c
        src/log.c
        src/main.c
        src/net.c
        src/peerfile.c
        src/searches.c
        src/utils.c
)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    SET(SOURCES ${SOURCES} src/tests.c)
    ADD_DEFINITIONS(-DDEBUG)
endif()

IF(UNIX)
    SET(SOURCES ${SOURCES} src/unix.c)
ENDIF()
IF(WIN32)
    SET(SOURCES ${SOURCES} src/unix.c src/windows.c)
ENDIF()


IF(CMD)
    SET(SOURCES ${SOURCES} src/ext-cmd.c)
    ADD_DEFINITIONS(-DCMD)
ENDIF()
IF(BOB)
    SET(SOURCES ${SOURCES} src/ext-bob.c src/ecc_point_compression.c)
    ADD_DEFINITIONS(-DBOB)
ENDIF()
IF(DNS)
    SET(SOURCES ${SOURCES} src/ext-dns.c)
    ADD_DEFINITIONS(-DDNS)
ENDIF()
IF(TLS)
    SET(SOURCES ${SOURCES} src/ext-tls-server.c src/ext-tls-client.c)
    ADD_DEFINITIONS(-DTLS)
ENDIF()
IF(LPD)
    SET(SOURCES ${SOURCES} src/ext-lpd.c)
    ADD_DEFINITIONS(-DLPD)
ENDIF()

IF(NATPMP)
    SET(SOURCES ${SOURCES} src/ext-fwd.c src/natpmp.c)
    ADD_DEFINITIONS(-DFWD -DFWD_NATPMP)
    ADD_LINK_OPTIONS(-Wl,-Bdynamic -lnatpmp)
ENDIF()
IF(UPNP)
    SET(SOURCES ${SOURCES} src/ext-fwd.c src/upnp.c)
    ADD_DEFINITIONS(-DFWD -DFWD_UPNP)
    ADD_LINK_OPTIONS(-Wl,-Bdynamic -lminiupnpc)
ENDIF()


add_executable(kadnode ${SOURCES})
target_link_libraries(kadnode mbedtls mbedx509 mbedcrypto)

=== Makefile ===

CFLAGS ?= -Wall -Wwrite-strings -pedantic
CFLAGS += -std=gnu99
LDFLAGS += -lc
FEATURES ?= dns lpd tls bob cmd debug nss #natpmp upnp

OBJS = build/searches.o build/kad.o build/log.o \
	build/conf.o build/net.o build/utils.o \
	build/announces.o build/peerfile.o \
	build/unix.o

ifeq ($(OS),Windows_NT)
  OBJS += build/windows.o
endif

.PHONY: all clean strip install kadnode \
	libnss_kadnode arch-pkg deb-pkg osx-pkg manpage install uninstall

all: kadnode


ifeq ($(findstring lpd,$(FEATURES)),lpd)
  OBJS += build/ext-lpd.o
  CFLAGS += -DLPD
endif

ifeq ($(findstring bob,$(FEATURES)),bob)
  OBJS += build/ext-bob.o build/ecc_point_compression.o
  CFLAGS += -DBOB
  LDFLAGS += -lmbedtls -lmbedx509 -lmbedcrypto
endif

ifeq ($(findstring cmd,$(FEATURES)),cmd)
  OBJS += build/ext-cmd.o
  CFLAGS += -DCMD
endif

ifeq ($(findstring debug,$(FEATURES)),debug)
  OBJS += build/tests.o
  CFLAGS += -g -DDEBUG
endif

ifeq ($(findstring dns,$(FEATURES)),dns)
  OBJS += build/ext-dns.o
  CFLAGS += -DDNS
endif

ifeq ($(findstring nss,$(FEATURES)),nss)
  OBJS += build/ext-nss.o
  CFLAGS += -DNSS
  EXTRA += libnss_kadnode
endif

ifeq ($(findstring tls,$(FEATURES)),tls)
  OBJS += build/ext-tls-client.o build/ext-tls-server.o
  CFLAGS += -DTLS
  LDFLAGS += -lmbedtls -lmbedx509 -lmbedcrypto
endif

ifeq ($(findstring upnp,$(FEATURES)),upnp)
  OBJS += build/upnp.o
  CFLAGS += -DFWD_UPNP
  LDFLAGS += -Wl,-Bdynamic -lminiupnpc
  ENABLE_FORWARDING = 1
endif

ifeq ($(findstring natpmp,$(FEATURES)),natpmp)
  OBJS += build/natpmp.o
  CFLAGS += -DFWD_NATPMP
  LDFLAGS += -Wl,-Bdynamic -lnatpmp
  ENABLE_FORWARDING = 1
endif

ifeq ($(ENABLE_FORWARDING),1)
  OBJS += build/ext-fwd.o
  CFLAGS += -DFWD
endif


build/%.o : src/%.c src/%.h
	$(CC) $(CFLAGS) -c -o $@ $<

libnss_kadnode:
	$(CC) $(CFLAGS) -fPIC -c -o build/ext-libnss.o src/ext-libnss.c
	$(CC) $(CFLAGS) -fPIC -c -o build/ext-libnss-utils.o src/ext-libnss-utils.c
	$(CC) $(CFLAGS) -fPIC -c -o build/ext-libnss-bsd.o src/ext-libnss-bsd.c
	$(CC) $(CFLAGS) $(LDFLAGS) -fPIC -shared -Wl,-soname,libnss_kadnode.so -o build/libnss_kadnode.so build/ext-libnss.o build/ext-libnss-utils.o build/ext-libnss-bsd.o

kadnode: build/main.o $(OBJS) $(EXTRA)
	$(CC) $(CFLAGS) build/main.o $(OBJS) $(LDFLAGS) -o build/kadnode
	ln -s kadnode build/kadnode-ctl 2> /dev/null || true

clean:
	rm -rf build/*

manpage:
	ronn --roff --manual=Kadnode\ Manual --organization=mwarning --date=2024-10-26 misc/manpage.md
	mv misc/manpage.1 misc/manpage

install:
	install -D -m755 -s build/kadnode $(DESTDIR)/usr/bin/
	ln -s kadnode $(DESTDIR)/usr/bin/kadnode-ctl || true
	install -D -m755 -s build/libnss_kadnode-2.0.so $(DESTDIR)/lib/libnss_kadnode.so.2 2> /dev/null || true

	install -D -m644 misc/kadnode.conf $(DESTDIR)/etc/kadnode/kadnode.conf
	install -D -m644 misc/peers.txt $(DESTDIR)/etc/kadnode/peers.txt

install_nss:
	sed -i -e '/kadnode/!s/^\(hosts:.*\)\s\{1,\}dns\(.*\)/\1 kadnode dns\2/' $(DESTDIR)/etc/nsswitch.conf 2> /dev/null || true

uninstall:
	rm -f $(DESTDIR)/usr/bin/kadnode
	rm -f $(DESTDIR)/usr/bin/kadnode-ctl
	rm -f $(DESTDIR)/lib/libnss_kadnode.so

	rm -f $(DESTDIR)/etc/kadnode/kadnode.conf
	rm -f $(DESTDIR)/etc/kadnode/peers.txt

uninstall_nss:
	sed -i -e 's/^\(hosts:.*\)kadnode \(.*\)/\1\2/' $(DESTDIR)/etc/nsswitch.conf 2> /dev/null || true

=== freebsd/Makefile ===
PORTNAME=	kadnode
DISTVERSIONPREFIX=	v
DISTVERSION=	2.4.0
PORTREVISION=	1
CATEGORIES=	dns

MAINTAINER=	moritzwarning@web.de
COMMENT=	P2P name resolution daemon
WWW=		https://github.com/mwarning/KadNode

LICENSE=	MIT
LICENSE_FILE=	${WRKSRC}/LICENSE

USES=		cpe gmake
USE_GITHUB=	yes
GH_ACCOUNT=	mwarning
GH_PROJECT=	KadNode
USE_RC_SUBR=	kadnode

MAKE_ENV=	FEATURES="${FEATURES}"
SUB_FILES=	kadnode.conf

OPTIONS_DEFINE=	AUTH CMD DEBUG DNS LPD NATPMP NSS UPNP
OPTIONS_DEFAULT=	AUTH CMD LPD NSS
OPTIONS_SUB=	yes

AUTH_DESC=	Authorization support based on mbedtls
CMD_DESC=	Command line control tool kadnode-ctl
DEBUG_DESC=	Build with debug messages and symbols
DNS_DESC=	Include local DNS interface
LPD_DESC=	Local peer discovery
NATPMP_DESC=	NAT-PMP support (remote port forwarding on the router)
NSS_DESC=	Name Service Switch support to intercept host queries
UPNP_DESC=	UPnP support (remote port forwarding on the router)

AUTH_LIB_DEPENDS=	libmbedtls.so:security/mbedtls3
AUTH_VARS=		FEATURES+="bob tls"

CMD_VARS=		FEATURES+="cmd"

DEBUG_VARS=		FEATURES+="debug"

DNS_VARS=		FEATURES+="dns"

LPD_VARS=		FEATURES+="lpd"

NATPMP_LIB_DEPENDS=	libnatpmp.so:net/libnatpmp
NATPMP_VARS=		FEATURES+="natpmp"

NSS_VARS=		FEATURES+="nss"

UPNP_LIB_DEPENDS=	libminiupnpc.so:net/miniupnpc
UPNP_VARS=		FEATURES+="upnp"

# for miniupnpc package
CFLAGS+=	-I${LOCALBASE}/include
LDFLAGS+=	-L${LOCALBASE}/lib

do-install:
	${INSTALL_PROGRAM} ${WRKSRC}/build/kadnode ${STAGEDIR}${PREFIX}/bin/
	${RLN} ${STAGEDIR}${PREFIX}/bin/kadnode ${STAGEDIR}${PREFIX}/bin/kadnode-ctl
	${MKDIR} ${STAGEDIR}${ETCDIR}
	${INSTALL_DATA} ${WRKSRC}/misc/peers.txt \
		${STAGEDIR}${ETCDIR}/peers.txt.sample
	${INSTALL_DATA} ${WRKDIR}/kadnode.conf \
		${STAGEDIR}${ETCDIR}/kadnode.conf.sample
	${INSTALL_MAN} ${WRKSRC}/misc/manpage \
		${STAGEDIR}${PREFIX}/share/man/man1/kadnode.1
do-install-NSS-on:
	${INSTALL_LIB} ${WRKSRC}/build/libnss_kadnode.so \
		${STAGEDIR}${PREFIX}/lib/nss_kadnode.so.1

.include <bsd.port.mk>

=== openwrt/kadnode/Makefile ===
include $(TOPDIR)/rules.mk


PKG_NAME:=kadnode
PKG_VERSION:=2.4.0
PKG_RELEASE:=1

PKG_SOURCE_PROTO:=git
PKG_SOURCE_URL:=https://github.com/mwarning/KadNode
PKG_SOURCE_VERSION:=v$(PKG_VERSION)
PKG_MIRROR_HASH:=9e5f503785f5f894f951c747c00586233b75254e91d2555f83b14ee2f07214c9

PKG_MAINTAINER:=Moritz Warning <moritzwarning@web.de>
PKG_LICENSE:=MIT

PKG_BUILD_PARALLEL:=1
PKG_BUILD_FLAGS:=gc-sections

include $(INCLUDE_DIR)/package.mk

define Package/kadnode
	SECTION:=net
	CATEGORY:=Network
	TITLE:=P2P DNS Resolver
	SUBMENU:=IP Addresses and Names
	URL:=https://github.com/mwarning/KadNode
	MENU:=1
	DEPENDS:=+KADNODE_ENABLE_BOB:libmbedtls +KADNODE_ENABLE_TLS:libmbedtls +KADNODE_ENABLE_UPNP:libminiupnpc +KADNODE_ENABLE_NATPMP:libnatpmp
endef

define Package/kadnode/description
	A P2P DNS system based on the BitTorrent network. It can be used as a decentralized DynDNS service.
endef

define Package/kadnode/config
	source "$(SOURCE)/Config.in"
endef

FEATURES = 

ifeq ($(CONFIG_KADNODE_ENABLE_CMD),y)
FEATURES += cmd
endif

ifeq ($(CONFIG_KADNODE_ENABLE_LPD),y)
FEATURES += lpd
endif

ifeq ($(CONFIG_KADNODE_ENABLE_TLS),y)
FEATURES += tls
endif

ifeq ($(CONFIG_KADNODE_ENABLE_BOB),y)
FEATURES += bob
endif

ifeq ($(CONFIG_KADNODE_ENABLE_DNS),y)
FEATURES += dns
endif

ifeq ($(CONFIG_KADNODE_ENABLE_UPNP),y)
FEATURES += upnp
endif

ifeq ($(CONFIG_KADNODE_ENABLE_NATPMP),y)
FEATURES += natpmp
endif

ifeq ($(CONFIG_KADNODE_ENABLE_DEBUG),y)
FEATURES += debug
endif

MAKE_FLAGS += FEATURES="$(FEATURES)"

define Package/kadnode/conffiles
/etc/config/kadnode
endef

define Package/kadnode/install
	$(INSTALL_DIR) $(1)/usr/bin
	$(INSTALL_BIN) $(PKG_BUILD_DIR)/build/kadnode $(1)/usr/bin/
ifeq ($(CONFIG_KADNODE_ENABLE_CMD),y)
	$(LN) kadnode $(1)/usr/bin/kadnode-ctl
endif
	$(INSTALL_DIR) $(1)/etc/init.d
	$(INSTALL_BIN) files/kadnode.init $(1)/etc/init.d/kadnode
	$(INSTALL_DIR) $(1)/etc/config
	$(INSTALL_CONF) files/kadnode.config $(1)/etc/config/kadnode
	$(INSTALL_DIR) $(1)/etc/uci-defaults
	$(INSTALL_BIN) files/kadnode.postinst $(1)/etc/uci-defaults/99_kadnode
endef

$(eval $(call BuildPackage,kadnode))

=== debian/changelog ===
kadnode (2.4.1) stable; urgency=medium

  * peers.txt add transmissionbt.com, libtorrent.org, remove openbittorrent.com
  * Debian, Arch: pid file location changed from /var/run/kadnode.pid to /run/
  * various bug fixes

 -- Moritz Warning <moritzwarning@web.de>  Sun, 24 Nov 2024 00:00:00 +0100

kadnode (2.4.0) stable; urgency=medium

  * fix compilation for mbedtls >=3.0.0
  * fix compilation for miniupnpc >=2.2.8
  * remove old searches after about an hour
  * use lower case Crockford base32 encoding
    * base16 is still accepted for input
  * add traffic statistics and uptime
  * support DHT isolation for private swarms
  * various bug fixes

 -- Moritz Warning <moritzwarning@web.de>  Wed, 06 Nov 2024 00:00:00 +0100

kadnode (2.3.0-1) stable; urgency=medium

  * update dht to 0.26
  * fix resolve peers to IPv6 address
  * ignore sigpipe globally (should fix some crashes)
  * fix ttl value for dns interface reply

 -- Moritz Warning <moritzwarning@web.de>  Mon, 10 Feb 2020 00:00:00 +0100

kadnode (2.2.5-1) stable; urgency=medium

  * replace stale unix socket files on startup
  * add freebsd nss code again, was removed by accident
  * remove linker flags from compile calls
  * fix freebsd nss module crash when no address was found

 -- Moritz Warning <moritzwarning@web.de>  Fri, 24 Aug 2018 03:27:44 +0100

=== archlinux/PKGBUILD ===
# Maintainer: Moritz Warning <moritzwarning@web.de>

pkgname=kadnode
pkgver=2.4.0
pkgrel=1

pkgdesc='A P2P based DNS resolver'
arch=('x86_64' 'i686')
url='http://github.com/mwarning/KadNode'
license=('MIT')
depends=('mbedtls')

backup=('etc/kadnode/kadnode.conf' 'etc/kadnode/peers.txt')

#source=(https://github.com/mwarning/KadNode/archive/v${pkgver}.tar.gz)
source=(git+https://github.com/mwarning/KadNode.git)

md5sums=('SKIP')

install="kadnode.install"

build() {
	cd ${srcdir}/KadNode
	make clean
	make FEATURES="bob tls cmd lpd nss"
}

package() {
	cd ${srcdir}/KadNode

	install -D -m755 build/kadnode ${pkgdir}/usr/bin/kadnode
	ln -s kadnode ${pkgdir}/usr/bin/kadnode-ctl

	install -D -m644 build/libnss_kadnode-2.0.so ${pkgdir}/usr/lib/libnss_kadnode.so.2

	# package systemd units go to /usr/lib/systemd, /etc is for admin override
	install -D -m644 archlinux/kadnode.service ${pkgdir}/usr/lib/systemd/system/kadnode.service
	install -D -m644 LICENSE ${pkgdir}/usr/share/licenses/${pkgname}/LICENSE
	install -D -m644 misc/manpage ${pkgdir}/usr/share/man/man1/kadnode.1

	install -D -m644 misc/kadnode.conf ${pkgdir}/etc/kadnode/kadnode.conf
	install -D -m644 misc/peers.txt ${pkgdir}/etc/kadnode/peers.txt
}

=== debian/control ===
Source: kadnode
Section: net
Priority: optional
Maintainer: Moritz Warning <moritzwarning@web.de>
Build-Depends: debhelper-compat (= 13), dh-sequence-installnss, libmbedtls-dev, libnatpmp-dev, libminiupnpc-dev
Standards-Version: 4.1.4
Homepage: https://github.com/mwarning/kadnode
Vcs-Git: https://github.com/mwarning/kadnode.git
Vcs-Browser: https://github.com/mwarning/kadnode
Bugs: https://github.com/mwarning/kadnode/issues
Rules-Requires-Root: no

Package: kadnode
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libnss3
Description: decentralized DynDNS alternative
 KadNode is a P2P DNS resolver that intercepts system requests for the
 p2p TLD. The decentralized BitTorrent DHT network is network is used
 to find IP addresses. Domains can be ECC crypto key in hex notations
 or domains that are backed by a Public Key Infrastructure (PKI).

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export FEATURES="bob tls cmd lpd dns nss natpmp upnp"

%:
	dh $@
